django-application/metaBase/urls.py
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.urls import include, re_path, path
from django.conf import settings
from django.views.generic.base import RedirectView
from django.views import defaults


urlpatterns = [
    re_path(r'^$',
        RedirectView.as_view(pattern_name='metabaseHome:index',
                             permanent=False)),
    re_path(r'^metabaseEditor/',
        include('metabaseEditor.urls')),
    re_path(r'^home/',
        include('metabaseHome.urls')),
    re_path(r'^browser/',
        include('metabaseBrowser.urls')),
    re_path(r'^api/',
        include('metabaseAPI.urls')),

    re_path(r'^login/$',
        auth_views.LoginView.as_view(), name='login'),
    re_path(r'^logout/$',
        auth_views.LogoutView.as_view(),
        {'next_page': '/login/'},
        name='logout'),

    re_path(r'^account/password_change/$',
        auth_views.PasswordChangeView.as_view(),
        name='password_change'),
    re_path(r'^account/password_change/done/$',
        auth_views.PasswordChangeDoneView.as_view(),
        name='password_change_done'),
    re_path(r'^account/password_reset/$',
        auth_views.PasswordResetView.as_view(),
        name='password_reset'),
    re_path(r'^account/password_reset/done/$',
        auth_views.PasswordResetDoneView.as_view(),
        name='password_reset_done'),
    path('account/reset/<uidb64>/<token>/',
        auth_views.PasswordResetConfirmView.as_view(),
        name='password_reset_confirm'),
    re_path(r'^account/reset/done/$',
        auth_views.PasswordResetCompleteView.as_view(),
        name='password_reset_complete'),

    re_path(r'^admin/', admin.site.urls),
    re_path(r'^admin/doc/', include('django.contrib.admindocs.urls'))
]

if settings.DEBUG:
    import debug_toolbar
    urlpatterns = [
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

def handler404(request, exception):
    return defaults.page_not_found(request, exception, template_name='error/404.html')

def handler500(request):
    return defaults.server_error(request, template_name='error/500.html')

def handler403(request, exception):
    return defaults.permission_denied(request, exception, template_name='error/403.html')

def handler400(request, exception):
    return defaults.bad_request(request, exception, template_name='error/400.html')

django-application/metabaseAPI/urls.py
from django.urls import re_path
from rest_framework.authtoken.views import obtain_auth_token
from . import views

app_name = 'metabaseAPI'

urlpatterns = [
    re_path(r'^$',
    views.api,
    name='api'),

    re_path(r'^project$',
        views.get_project_list_json.as_view(),
        name='get_project_list_json'),

    re_path(r'^project/get_list$',
        views.download_project_list,
        name='download_project_list'),

    re_path(r'^project/(?P<project_id>[0-9]+)/tube_list$',
        views.get_tube_id_from_project_name.as_view(),
        name='get_tube_id_from_project_name'),
    re_path(r'^project/(?P<project_id>[0-9]+)/sample_list$',
        views.get_project_samples_json.as_view(),
        name='get_project_samples_json'),
    re_path(r'^project/(?P<project_id>[0-9]+)/download_tube_list$',
        views.download_project_tubes,
        name='download_tube_list'),
    re_path(r'^project/(?P<project_id>[0-9]+)/download_project_samples_list$',
        views.download_project_samples_list,
        name='download_project_samples_list'),

    re_path(r'^tube/get-list$',
    views.TubeSamplesView.as_view(),
    name='get_samples_list'),
    re_path(r'^tube/(?P<tube_name>[^/]+)/tube_list$',
        views.get_tube_id_from_name.as_view(),
        name='get_tube_id_from_name'),
    re_path(r'^tube/(?P<tube_id>[0-9]+)/download_tube_list$',
        views.download_tubes_list,
        name='download_tubes_list'),
    re_path(r'^tube/(?P<tube_id>[0-9]+)/sample_list$',
        views.get_tube_samples_list_json.as_view(),
        name='get_tube_samples_list_json'),
    re_path(r'^tube/(?P<tube_id>[0-9]+)/download_samples_list$',
        views.download_tube_samples_list,
        name='download_tube_samples_list'),
    re_path(r'^tube/(?P<tube_id>[0-9]+)/ngs_filter$',
        views.ngs_filter.as_view(),
        name='ngs_filter_file'),
    re_path(r'^tube/(?P<tube_id>[0-9]+)/download_ngs_filter$',
        views.download_ngs_filter,
        name='download_ngs_filter'),

    re_path(r'^sample/get-list$',
    views.SampleQualifiersView.as_view(),
    name='get_samples_list'),
    re_path(r'^sample/(?P<sample_id>[0-9]+)/qualifiers',
        views.get_sample_qualifier.as_view(),
        name='get_sample_qualifier'),
    re_path(r'^sample/(?P<sample_id>[0-9]+)/download_qualifiers_list',
        views.download_qualifiers_list,
        name='download_qualifiers_list'),

    re_path(r'^get-auth-token/$', obtain_auth_token, name='get-auth-token')
    ]

django-application/metabaseEditor/urls.py
from django.urls import path, re_path
from . import views

app_name = 'metabaseEditor'

project_url = r'^project/(?P<project_id>[^/]+)/'
experiement_url = r'experiment/(?P<submission_file_id>[^/]+)'
sequencing_url = r'sequencing/(?P<sequencing_file_id>[^/]+)'

urlpatterns = [
    re_path(r'^project/create$',
        views.create_project,
        name='create_project'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/$',
        views.manage_project,
        name='manage_project'),
    re_path(r'^project/load_project$',
        views.load_project,
        name='load_project'),
    re_path(project_url + r'delete$',
        views.delete_project,
        name='delete_project'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/users/get$',
        views.get_project_users,
        name='get_project_users'),

    re_path(project_url + r'subproject/delete/information$',
        views.project.get_delete_info_subproject,
        name='get_delete_info_subproject'),
    re_path(project_url + r'experiment-file/delete/information$',
        views.project.get_delete_info_submission_file,
        name='get_delete_project_info_submission_file'),
    re_path(project_url + r'libraries/delete/information$',
        views.project.get_delete_info_libraries,
        name='get_delete_project_info_libraries'),
    re_path(project_url + r'tubes/delete/information$',
        views.project.get_delete_info_tubes,
        name='get_delete_project_info_tubes'),
    re_path(project_url + r'plates/delete/information$',
        views.project.get_delete_info_plates,
        name='get_delete_project_info_plates'),
    re_path(project_url + r'samples/delete/information$',
        views.project.get_delete_info_samples,
        name='get_delete_project_info_samples'),
    re_path(project_url + r'extracts/delete/information$',
        views.project.get_delete_info_extracts,
        name='get_delete_project_info_extracts'),

    re_path(project_url + r'experiment_list$',
        views.project.get_deleted_submission_files,
        name='get_deleted_submission_files'),
    re_path(project_url + r'delete/identify$',
        views.project.identify_deleted_project,
        name='identify_deleted_project'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/write_delete_messages$',
        views.write_delete_messages,
        name='write_delete_messages'),

    re_path(project_url + r'parent-project/delete/identify$',
        views.project.identify_deleted_parent_project,
        name='identify_deleted_parent_project'),
    re_path(project_url + r'parent-project/delete$',
        views.project.delete_parent_project,
        name='delete_parent_project'),

    re_path(project_url + 'information/update$',
        views.update_project_information,
        name='update_project_information'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/experiment/get_data$',
        views.get_project_experiment,
        name='get_project_experiment'),
    re_path("^project/[0-9]+/" + experiement_url + r'/download$',
        views.export_submission_file,
        name='download_experiment'),

    re_path(project_url + r'file/import/check$',
        views.check_file_import,
        name='check_file_import'),
    re_path(project_url + r'samples/import/check$',
        views.check_samples_import,
        name='check_samples_import'),
    re_path(project_url + r'extracts/import/check$',
        views.check_extracts_import,
        name='check_extracts_import'),
    re_path(project_url + r'controls/import/check$',
        views.check_controls_import,
        name='check_controls_import'),
    re_path(project_url + r'pcrs/import/check$',
        views.check_pcrs_import,
        name='check_pcrs_import'),
    re_path(project_url + r'plates/import/check$',
        views.check_plates_import,
        name='check_plates_import'),
    re_path(project_url + r'tubes/import/check$',
        views.check_tubes_import,
        name='check_tubes_import'),
    re_path(project_url + r'write_messages$',
        views.write_messages,
        name='check_write_messages'),
    re_path(project_url + r'import/check/clear$',
        views.remove_imported_data_on_fail,
        name='remove_imported_data_on_fail'),

    re_path(project_url + r'fileAndTube/import$',
        views.import_file_and_tube,
        name='import_file_and_tube'),
    re_path(project_url + r'pcr_plates/import$',
        views.import_pcr_plate,
        name='import_pcr_plate'),
    re_path(project_url + r'samples/import$',
        views.import_samples,
        name='import_samples'),
    re_path(project_url + r'extracts/import$',
        views.import_extracts,
        name='import_extracts'),

    re_path(project_url + r'fileAndTube/import/remove$',
        views.remove_file_tube_on_fail,
        name='remove_file_and_tube_on_fail'),
    re_path(project_url + r'pcr_plates/import/remove$',
        views.remove_plate_on_fail,
        name='remove_pcr_plate_on_fail'),
    re_path(project_url + r'samples/import/remove$',
        views.remove_samples_on_fail,
        name='remove_samples_on_fail'),
    re_path(project_url + r'extracts/import/remove$',
        views.remove_extracts_on_fail,
        name='remove_extracts_on_fail'),

    re_path(project_url + r'unlink_tube_and_pcrs$',
        views.project.unlink_pcr_tube,
        name='unlink_tube_submission_file'),
    re_path(project_url + r'unlink_project_tube$',
        views.project.unlink_project_tube,
        name='unlink_project_tube'),
    re_path(project_url + r'remove_project_tube$',
        views.project.remove_project_tube_wo_lib,
        name='remove_project_tube_wo_lib'),

    re_path("^project/[0-9]+/" + experiement_url + r'/libraries/delete/information$',
        views.experiment.get_delete_info_libraries,
        name='get_delete_info_libraries'),
    re_path("^project/[0-9]+/" + experiement_url + r'/tubes/delete/information$',
        views.experiment.get_delete_info_tubes,
        name='get_delete_info_tubes'),
    re_path("^project/[0-9]+/" + experiement_url + r'/plates/delete/information$',
        views.experiment.get_delete_info_plates,
        name='get_delete_info_plates'),
    re_path("^project/[0-9]+/" + experiement_url + r'/samples/delete/information$',
        views.experiment.get_delete_info_samples,
        name='get_delete_info_samples'),
    re_path("^project/[0-9]+/" + experiement_url + r'/extracts/delete/information$',
        views.experiment.get_delete_info_extracts,
        name='get_delete_info_extracts'),

    re_path(project_url + experiement_url + r'/file/delete/identify$',
        views.experiment.identify_deleted_submission_file,
        name='identify_deleted_submission_file'),
    re_path("^project/[0-9]+/" + experiement_url + r'/tubes/delete/identify$',
        views.experiment.identify_deleted_tubes,
        name='identify_deleted_tubes'),
    re_path("^project/[0-9]+/" + experiement_url + r'/plates/delete/identify$',
        views.experiment.identify_deleted_plates_primers,
        name='identify_deleted_plates_primers'),
    re_path("^project/[0-9]+/" + experiement_url + r'/samples/delete/identify$',
        views.experiment.identify_deleted_samples,
        name='identify_deleted_samples'),
    re_path("^project/[0-9]+/" + experiement_url + r'/extracts/delete/identify$',
        views.experiment.identify_deleted_extracts,
        name='identify_deleted_extracts'),

    re_path(project_url + experiement_url + r'/file/delete$',
        views.experiment.delete_submission_file,
        name='delete_file'),
    re_path("^project/[0-9]+/" + experiement_url + r'/tubes/delete$',
        views.experiment.delete_tubes,
        name='delete_tubes'),
    re_path("^project/[0-9]+/" + experiement_url + r'/plates/delete$',
        views.experiment.delete_plates,
        name='delete_plates'),
    re_path("^project/[0-9]+/" + experiement_url + r'/samples/delete$',
        views.experiment.delete_samples,
        name='delete_samples'),
    re_path("^project/[0-9]+/" + experiement_url + r'/controls/delete$',
        views.experiment.delete_controls,
        name='delete_controls'),
    re_path("^project/[0-9]+/" + experiement_url + r'/primers/delete$',
        views.experiment.delete_primers,
        name='delete_primers'),

    re_path(project_url + experiement_url + r'/unlink_tube_and_pcrs$',
        views.experiment.unlink_pcr_tube,
        name='unlink_tube_submission_file'),
    re_path(project_url + experiement_url + r'/unlink_exp_tube$',
        views.experiment.unlink_tube_submission_file,
        name='unlink_tube_submission_file'),
    re_path(project_url + experiement_url + r'/remove_exp_tube$',
        views.experiment.remove_exp_tube_wo_lib,
        name='remove_exp_tube_wo_lib'),

    re_path(r'^sequencing/?$',
        views.manage_sequencing,
        name='manage_sequencing'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/sequencing/get_data$',
        views.get_project_sequencing,
        name='get_project_sequencing'),
    re_path(sequencing_url + r'/information$',
        views.sequencing.get_information,
        name='get_sequencing_information'),
    re_path(project_url + r'get_library_and_tube_information$',
        views.get_library_and_tube_information,
        name='get_library_and_tube_information'),
    re_path(project_url + r'sequencing/library/link$',
        views.link_library,
        name='link_library'),
    re_path(project_url + r'library/unlink$',
        views.unlink_library,
        name='unlink_library'),
    re_path(project_url + r'sequencing/import$',
        views.add_sequencing,
        name='project_import_sequencing'),
    re_path(sequencing_url + r'/remove$',
        views.remove_sequencing,
        name='remove_sequencing'),
    re_path(r'^sequencing/get_sequencing_information$',
        views.get_sequencing_information, name='get_sequencing_information'),
    re_path(r'^sequencing/import/check$',
        views.check_sequencing_import,
        name='check_sequencing_import'),

django-application/metabaseHome/urls.py
from django.urls import re_path
from . import views

app_name = 'metabaseHome'

urlpatterns = [
    re_path(r'^$',
        views.index,
        name='index'),
    re_path(r'^myaccount',
        views.myaccount,
        name='myaccount'),
    re_path(r'^experiment/file/template/download',
        views.export_template,
        name='export_experiment_template'),
    re_path(r'^experiment/file/template-with-macro/download',
        views.export_template_with_macro,
        name='export_experiment_template_with_macro'),
    re_path(r'^experiment/file/notice/download',
        views.export_experiment_notice,
        name='export_experiment_notice'),
    re_path(r'^sequencing/file/template/download',
        views.export_sequencing_template,
        name='export_sequencing_template'),
    re_path(r'^sequencing/file/notice/download',
        views.export_sequencing_notice,
        name='export_sequencing_notice'),
]

django-application/metabaseHome/models.py
from django.db import models

# Create your models here.

django-application/metabaseHome/templates/index.html
{% extends "base.html" %}
{% load auth_extras %}

{% block nav %}
{% include "parts/nav.html" with active_tab="home" %}
{% endblock %}

{% block jumbotron %}
<h1>MetaBase</h1>
<p>
  The metabarcoding database.
</p>
{% endblock %}

{% block content %}
<div class="row">
  <div class="col-md-6 py-2">
    <div class="card h-100">
      <div class="card-header">
        <h2>Project</h2>
      </div>
      <div class="card-body">
        <p>
          Allows to add, update and delete project into metaBase database.
          In this part you can update project information, add experiments and link libraries to a project.
        </p>
      </div>
      <div class="card-footer text-center">
        <a href={% url "metabaseEditor:manage_project" %} class="btn btn-outline-success {% if not user|has_permission:"editor" %}disabled{%endif%}">Manage</a>
      </div>
    </div>
  </div>
  <div class="col-md-6 py-2">
    <div class="card h-100">
      <div class="card-header">
        <h2>Experiment file template</h2>
      </div>
      <div class="card-body">
        <p>
          Required file to import experiment data.
        </p>
      </div>
      <div class="card-footer text-center">
        <a href={% url "metabaseHome:export_experiment_template" %} class="btn btn-outline-success">Download experiment file</a>
        <a href={% url "metabaseHome:export_experiment_template_with_macro" %} class="btn btn-outline-success">Download experiment file with macro</a>
        <a href={% url "metabaseHome:export_experiment_notice" %} class="btn btn-outline-success">Download notice</a>
      </div>
    </div>
  </div>
</div>
<div class="row">
  <div class="col-md-6 py-2">
    <div class="card h-100">
      <div class="card-header">
        <h2>Sequencing information</h2>
      </div>
      <div class="card-body">
        <p>
          Allows to add and delete sequencing information file into metaBase database.
        </p>
      </div>
      <div class="card-footer text-center">
        <a href={% url "metabaseEditor:manage_sequencing" %} class="btn btn-outline-success {% if not user|has_permission:"editor" %}disabled{%endif%}">Manage</a>
      </div>
    </div>
  </div>
  <div class="col-md-6 py-2">
    <div class="card h-100">
      <div class="card-header">
        <h2>Sequencing file template</h2>
      </div>
      <div class="card-body">
        <p>
          Required file to import sequencing data when the file is not a Fasterix xml file.
        </p>
      </div>
      <div class="card-footer text-center">
        <a href={% url "metabaseHome:export_sequencing_template" %} class="btn btn-outline-success">Download sequencing file</a>
        <a href={% url "metabaseHome:export_sequencing_notice" %} class="btn btn-outline-success">Download notice</a>
      </div>
    </div>
  </div>
</div>
<div class="row">
  <div class="col-md-6 py-2">
    <div class="card h-100">
      <div class="card-header">
        <h2>Browser</h2>
      </div>
      <div class="card-body">
        <p>
          Allows to search information from metabarcoding project into metaBase database.
        </p>
      </div>
      <div class="card-footer text-center">
        <a href={% url "metabaseBrowser:browser" %} class="btn btn-outline-success center">Browse</a>
      </div>
    </div>
  </div>
  <div class="col-md-6 py-2">
    <div class="card h-100">
      <div class="card-header">
        <h2>API</h2>
      </div>
      <div class="card-body">
        <p>
          Allows to get data from an API command.
        </p>
      </div>
      <div class="card-footer text-center">
        <a href={% url "metabaseAPI:api" %} class="btn btn-outline-success center">API</a>
      </div>
    </div>
  </div>
</div>
{% endblock %}

django-application/metabaseHome/templates/myaccount.html
{% extends "base.html" %}
{% load widget_tweaks %}
{% load static %}

{% block title %}My account{% endblock %}

{% block nav %}
  {% include "parts/nav.html" with active_tab="my_account" %}
{% endblock %}

{% block jumbotron %}
  <h1>My account</h1>
  <p>Information about your Metabase account</p>
{% endblock %}

{% block messages %}
  <div id="messages">
    {%include "parts/information-message.html" %}
  </div>
{% endblock %}
{% block content %}
  <h3>General information</h3>

  <div class="row">
    <label class="col-sm-2">Lastname:</label>
    <div class="col-sm-5">
      {{user.last_name}}
    </div>
  </div>
  <div class="row">
    <label class="col-sm-2">Firsttname:</label>
    <div class="col-sm-5">
      {{user.first_name}}
    </div>
  </div>
  <div class="row">
    <label class="col-sm-2">Email:</label>
    <div class="col-sm-5">
      {{user.email}}
    </div>
  </div>
  <div class="row">
    <label class="col-sm-2">Last login:</label>
    <div class="col-sm-5">
      {{user.last_login}}
    </div>
  </div>
  <div class="row">
    <label class="col-sm-2">Date joined:</label>
    <div class="col-sm-5">
      {{user.date_joined}}
    </div>
  </div>
  <div class="row">
    <label class="col-sm-2">API token command:</label>
    <div class="col-sm-5">
      Authorization: Token {{token.key}}
    </div>
  </div>

  <h3 class="mt-4">Password change</h3>

  {% with WIDGET_ERROR_CLASS="is-invalid" %}
  <form method="post">
    {% csrf_token %}

    <div class="form-group row">
      <label class="col-sm-3 col-form-label" for="{{ form.old_password.id_for_label }}">Old password:</label>
      <div class="col-sm-5">
        {% render_field form.old_password class="form-control"%}
        {%if form.old_password.errors%}
          {%for error in form.old_password.errors%}
            <div class="invalid-feedback">{{ error }}</div>
          {%endfor%}
        {%endif%}
      </div>
    </div>

    <div class="form-group row">
      <label class="col-sm-3 col-form-label" for="{{ form.new_password1.id_for_label }}">New password:</label>
      <div class="col-sm-5">
        {% render_field form.new_password1 class="form-control"%}
        {%if form.new_password1.errors%}
          {%for error in form.new_password1.errors%}
            <div class="invalid-feedback">{{ error }}</div>
          {%endfor%}
        {%endif%}
      </div>
    </div>

    <div class="form-group row">
      <label class="col-sm-3 col-form-label" for="{{ form.new_password2.id_for_label }}">New password confirmation:</label>
      <div class="col-sm-5">
        {% render_field form.new_password2 class="form-control"%}
        {%if form.new_password2.errors%}
          {%for error in form.new_password2.errors%}
            <div class="invalid-feedback">{{ error }}</div>
          {%endfor%}
        {%endif%}
      </div>
    </div>

    <div class="form-group row">
      <div class="col-sm-11 text-center">
        <button class="btn btn-success" type="submit">Change password</button>
      </div>
    </div>

  </form>
  {%endwith%}

{% endblock %}